<?php
//====================================================================================
///                                                Fichier : DocXml_FicheXML.php
///===================================================================================
///
/// Traitement d'un document XML : Affichage d'une fiche ou d'un formulaire adhoc
///
/// Dans la fiche, chaque balise est de la forme
///    <balise>valeur</balise>
///
/// ou, dans le cas o plusieurs valeurs sont possibles (choix de type "checkbox" par exemple)
///    <balise>valeur1;valeur2;...;valeurk</balise>
///
/// ou, dans le cas o la valeur a t extraite de la base (choix de type "select")
///    <balise>valeur_cl_primaire,valeur_balise</balise>
///
///====================================================================================
///
/// Le modle de fiche est d'abord trait.
/// Le code HTML ainsi gnr est ensuite analys
///    et les valeurs des balises XML de la fiche y sont renseignes.
///
/// Le code HTML ventuellement prsent dans les valeurs des balises XML de la fiche
///    - y est trouv sous la forme "<baliseHTML>" - cf. processXML()
///    - est laiss sous cette forme  - cf. nouvelleFiche.php
///
/// NB : Les handlers de ce fichier sont communs  tous les types de fiche.
///
///====================================================================================
///    function FicheXML_startElementHandler($parser, $name, $attribs) { global $debugAppli;
    function FicheXML_startElementHandler($parser, $name, $attribs) { global $debugAppli;
///====================================================================================
/// Traitement d'une balise ouvrante
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $name     Nom de la balise ouvrante
///    $attribs  Attributs de la balise
///
///====================================================================================
      global $DocXmlHandler, $TypeDocXML;
      global $baliseEnCours, $attributsBaliseEnCours;
      global $attributsBalises, $nivImbriqBalise;
      global $attributsModele, $valeursFiche, $xmlDataOut;
      global $xml_Fiche_Formulaire;
///------------------------------------------------------------------------------------
///
if($debugAppli) $debugAppli->show($name,'FicheXML_startElementHandler --- name');
if($debugAppli) $debugAppli->show($attribs,'FicheXML_startElementHandler --- attribs');
      switch($name) {

        case 'DocumentXML' :
//------------------------------------------------------------------------------------
/// Rcuperer et analyser le modle associ
/// NB : Ce traitement est commun  tous les types de fiches

// Sauver les variable globales

          $sav_DocXmlHandler = $DocXmlHandler;  // Ex: FicheClub (dfaut : FicheXML)
          $sav_TypeDocXML    = $TypeDocXML;     // Ex: FicheClub (mme si traitement du modle)
          $sav_xmlDataOut    = $xmlDataOut;
          $sav_baliseEnCours = $baliseEnCours;
          $sav_attributsBaliseEnCours = $attributsBaliseEnCours;
          $sav_attributsBalises       = $attributsBalises;
          $sav_nivImbriqBalise        = $nivImbriqBalise;

//------------------------------------------------------------------------------------
/// Traiter le modle
///
/// Une variable globale '$attributsModele' sera cre, telle que
///       $attributsModele[balise]['defaut'] = Valeur par dfaut de la balise 'balise'
///
/// NB: Les balises du modle xml seront traites par "DocXmL_ModeleFicheXML.php"

          $attributsModele = array();
          $valeursFiche    = array();

          $dataOut = processXML('', "Modele$TypeDocXML"); // On traite le modle

if($debugAppli) $debugAppli->show('',"----- DocXML$TypeDocXML ----- Bilan traitement modle");
if($debugAppli) $debugAppli->show($attributsModele,"attributsModele");
if($debugAppli) $debugAppli->show('',"----------------------------------------------");
//------------------------------------------------------------------------------------
// Restaurer les variables globales

          $DocXmlHandler = $sav_DocXmlHandler;
          $TypeDocXML    = $sav_TypeDocXML;
          $xmlDataOut    = $sav_xmlDataOut;
          $baliseEnCours = $sav_baliseEnCours;
          $attributsBaliseEnCours = $sav_attributsBaliseEnCours;
          $attributsBalises       = $sav_attributsBalises;
          $nivImbriqBalise        = $sav_nivImbriqBalise;

          $xmlDataOut .= $dataOut;
          break;

        default:

      } // Fin switch($name)


    } // Fin function FicheXML_startElementHandler($parser, $name, $attribs)


///
///====================================================================================
///    function FicheXML_characterDataHandler($parser, $data) { global $debugAppli;
    function FicheXML_characterDataHandler($parser, $data) { global $debugAppli;
///====================================================================================
/// Traitement de texte hors balise
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $data     Texte  traiter
///
///====================================================================================
      global $baliseEnCours, $attributsBaliseEnCours, $xml_Fiche_Formulaire;
      global $attributsModele, $valeursFiche;
//------------------------------------------------------------------------------------
/// Mmoriser les attributs de la fiche
if($debugAppli) if($dataIn) $debugAppli->show($dataIn.'=>'.RestaurerCodeHTML($dataIn),"$baliseEnCours - dans FicheXML_characterDataHandler");

      if(eregi("[a-z0-9_]", $data)) {
        $dataIn = str_replace ('"', "'", stripSlashes($data));
      } else {
        $dataIn = '';
      }

      $valeursFiche[$baliseEnCours] .= RestaurerCodeHTML($dataIn);

    } // Fin function FicheXML_characterDataHandler($parser, $data)


///
///====================================================================================
///    function FicheXML_endElementHandler($parser, $name) { global $debugAppli;
    function FicheXML_endElementHandler($parser, $name) { global $debugAppli;
///====================================================================================
/// Traitement d'une balise fermante
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $name     Nom de la balise fermante
///
///====================================================================================
      global $xmlDataOut, $valeursFiche;
      global $xml_Fiche_Formulaire;
      global $html_ok_dans_fiche;
//------------------------------------------------------------------------------------
//
      switch($name) {

        case 'DocumentXML' :

          renseignerBalisesDsModele();

          break;

        default:

      } // Fin switch($name)

    } // Fin function FicheXML_endElementHandler($parser, $name)


///====================================================================================
///====================================================================================
/// function renseignerBalisesDsModele() { global $debugAppli;
        function renseignerBalisesDsModele() { global $debugAppli;
///====================================================================================
///
/// Renseigner les attributs de la fiche (ou ceux par dfaut), dans le modle
///
/// Variables globales
///   $xmlDataOut
///   $valeursFiche
///   $xml_Fiche_Formulaire
///   $html_ok_dans_fiche
///
/// Activation
///   Traitement de la balise </DocumentXML> dans les procdures suivantes :
///      - ${TypeDocXML}_endElementHandler
///      - Modele${TypeDocXML}_endElementHandler   si $xml_ProcessXML_Requete='NouvelleFiche'
///
///====================================================================================
          global $xmlDataOut, $valeursFiche, $attributsModele;
          global $xml_Fiche_Formulaire, $html_ok_dans_fiche;
///------------------------------------------------------------------------------------
///
/// Ajouter les paramtres de style (cf. "setStyleInSheet()" dans "mes_fonctions.php3")
    if(function_exists(setStyleInSheet)) setStyleInSheet();

/// Renseigner les balises internes 'userId', 'userName' et 'userEmail'
/// NB: Ces balises contiennent le code PHP permettant leur renseignement
///     lors de l'affichage du formulaire
    if(!$valeursFiche['userId'])    $valeursFiche['userId']    = '<'.'?=$userId?'.'>';
    if(!$valeursFiche['userName'])  $valeursFiche['userName']  = '<'.'?=$userName?'.'>';
    if(!$valeursFiche['userEmail']) $valeursFiche['userEmail'] = '<'.'?=$userEmail?'.'>';

//if($debugAppli) $debugAppli->show($xmlDataOut, 'renseignerBalisesDsModele - xmlDataOut');
if($debugAppli) $debugAppli->show($valeursFiche, 'renseignerBalisesDsModele - valeursFiche');
//------------------------------------------------------------------------------------
/// Excuter les requtes sur la base pour renseigner les champs de TypeInput='Select...'
/// Syntaxe: ...!z!balise!z!sql!z!...  avec sql='SELECT chpId,chpTxt FROM...WHERE chpId IN '
///
          if($regs = explode('!z!', $xmlDataOut)) {

            $xmlDataOut = '';
            for($i=0; $i<count($regs); $i+=3) {
              $xmlDataOut .= $regs[$i];
              $balise = $regs[$i+1];
              $sql    = $regs[$i+2];
if($debugAppli) $debugAppli->show($valeursFiche[$balise], "renseignerBalisesDsModele !z! - valeursFiche[$balise]");

              $sql1 = '';
              if($balise &&
                 $valFiches=explode(';',$valeursFiche[$balise])) {  // Valeurs  traiter
                $sep = '';
                foreach($valFiches as $valFiche)
                  if($val=ereg_replace(' *,.*$', '', $valFiche)) {  // Ne prendre que la 1re valeur
                    $sql1 .= $sep.$val;
                    $sep = ',';
                  } // Fin foreach($valFiches as $valFiche) if($val=ereg_replace...)

                if($sql1) {
                  $sql .= "($sql1)";
if($debugAppli) $debugAppli->show($sql, 'sql');
                  $res = spip_query($sql);                          // Rcuprer les champs
                  $sep = '';
              		while(list($id,$txt)=mysql_fetch_row($res)) {
                    if($txt && eregi("[a-z0-9]", $txt)) {           // Valeur non vide
                      $txt = str_replace ('"', "'", stripSlashes($txt));
                    } else {
                      $txt = '';
                    }
if($debugAppli) $debugAppli->show($txt, "id=$id - txt");
                    $xmlDataOut .= $sep.noSpace( noNumero( $txt ) );
                    $sep = ', ';
                  }
                  mysql_free_result($res);
                } // Fin if($sql1)

              } // Fin if($balise && $valFiches=...)

            } // Fin for($i=0; $i<count($regs); $i++)

          } // Fin if($regs = explode('!z!', $xmlDataOut))

///------------------------------------------------------------------------------------
///     Balayer les champs de la fiche
//------------------------------------------------------------------------------------
///
          foreach($valeursFiche as $balise=>$valFiche) {

//------------------------------------------------------------------------------------

            if($valFiche) $valFiche = str_replace ('"', "'", stripSlashes($valFiche));

if($debugAppli) $debugAppli->show($valFiche, "================= renseignerBalisesDsModele - valeursFiche[$balise]");
///     => Vrifier les balises html
///        NB: On accepte du code php dans les balises internes "userXxxx"
            if(!strpos('_,userId,userName,userEmail,', ",$balise,")) {
              if(!$html_ok_dans_fiche) {
                $valFiche = str_replace('<','&lt;', $valFiche);
  ///     => On accepte les balises html... mais refuser les balises dangereuses
              } else {
                $balisesInterdites = array('link','script','?','?php','!--',
                                           'form','input','select','option','/option','submit',
                                           'textarea','/textarea',
                                           'embed','object');
                foreach($balisesInterdites as $baliseKO) {
                  $valFiche = str_replace("<$baliseKO", "&lt;$baliseKO", $valFiche);
                }
              } // Fin if(!$html_ok_dans_fiche)
            } // Fin if(!strpos('_,userId,userName,userEmail,", ",$balise,")

//------------------------------------------------------------------------------------
///     Traiter les valeurs conditionnelles : !w!balise!w!test!w!valeur!w!
///     => Si "valeursFiche[balise]"="test" alors afficher "valeur"
///        En particulier :
///           => Renseigner l'attribut 'CHECKED' des balises html 'RADIO' et 'CHECKBOX'
///           => Renseigner l'attribut 'SELECTED' des balises html <SELECT><OPTION>
            $vals = explode(';', $valFiche);
            if($vals) foreach($vals as $val) {
              $val = protectRegExp($val);
if($debugAppli) $debugAppli->show($val, "renseignerBalisesDsModele - !w!balise!w!val!w!=$balise - val");
              $val1 = str_replace('?', '\\?', $val);
              $xmlDataOut = ereg_replace("!w!$balise!w!$val1!w!(([^!]|![^/]|!/[^w]|!/w[^!])*)!/w!", "\\1", $xmlDataOut);
            }

//------------------------------------------------------------------------------------
///     Prparer l'attribut 'VALUE des balises html <INPUT NAME='ValBalises[]'>
            $valeurFiche = $valFiche;    // Texte inchang

///     => Affichage : Appliquer les filtres ventuels (cf. $attributsModele[$balise]['Filtre'])
            if($xml_Fiche_Formulaire!='Form') {
              if($filtres=$attributsModele[$balise]['Filtre']) {
                $filtres = explode(',', $filtres);
                foreach($filtres as $filtre) eval( "\$valeurFiche = $filtre"."(\$valeurFiche);" );
              } // Fin if($filtres...
if($debugAppli) $debugAppli->show($valeurFiche, "renseignerBalisesDsModele - balise=$balise - valeurFiche");

///     => Formulaire : Appliquer les filtres ventuels (cf. $attributsModele[$balise]['FiltreToInput'])
            } else { // suite if($xml_Fiche_Formulaire!='Form')
              if($filtres=$attributsModele[$balise]['FiltreToInput']) {
                $filtres = explode(',', $filtres);
                foreach($filtres as $filtre) eval( "\$valeurFiche = $filtre"."(\$valeurFiche);" );
              } // Fin if($filtres...
            } // Fin if($xml_Fiche_Formulaire!='Form')

//------------------------------------------------------------------------------------
///     Traiter !x!balise!x! : afficher "valeursFiche[balise]" aprs mise en page SPIP
            $val = $valeurFiche;
            if($xml_Fiche_Formulaire!='Form') $val = propre($val);

            $xmlDataOut = str_replace("!x!$balise!x!", $val, $xmlDataOut);

//------------------------------------------------------------------------------------
///     Traiter les valeurs conditionnelles  !v!balise!v!valeur!/v!
///     => Si valeursFiche[balise] est vide, ne rien afficher
            if(!eregi('[a-z0-9]', $valeurFiche)) {
              $xmlDataOut = ereg_replace("!v!$balise!v!([^!]|![^/]|!/[^v]|!/v[^!])*!/v!",'', $xmlDataOut);
///     => Sinon, afficher "valeur"
            } else {
              $xmlDataOut = ereg_replace("!v!$balise!v!(([^!]|![^/]|!/[^v]|!/v[^!])*)!/v!",'\1', $xmlDataOut);
            }

//------------------------------------------------------------------------------------
///     Traiter les champs "url rubrique"  !yr!$balise!yr!
///     => Si valeursFiche[balise]="id,texte", afficher un lien vers la rubrique "id"
///     => Sinon, afficher "valeur"
            $vals = split(' *; *', $valeurFiche);
            $lien = '';
            $sep  = '';
            foreach($vals as $val) {
              list($id,$texte) = explode(',', $val);
              if(eregi('^[0-9]+$', $id) && $texte)
                $lien .= $sep."<A HREF='rubrique.php3?id_rubrique=$id'>$texte</A>";
              else $lien .= $sep.$val;
              $sep = ', ';
            }
            $xmlDataOut = str_replace("!yr!$balise!yr!", $lien, $xmlDataOut);

//------------------------------------------------------------------------------------
///     Traiter les valeurs conditionnelles  !y!balise!y!valeur!/y!
///     => Si valeursFiche[balise] est une url, afficher "valeur"
///        (on teste surtout la non-prsence d'espaces et d'apostrophes)
            if(verifUrl($valeurFiche)) {
              $xmlDataOut = ereg_replace("!y!$balise!y!(([^!]|![^/]|!/[^y]|!/y[^!])*)!/y!",'\1', $xmlDataOut);
///     => Sinon, ne rien afficher
            } else {
              $xmlDataOut = ereg_replace("!y!$balise!y!([^!]|![^/]|!/[^y]|!/y[^!])*!/y!",'', $xmlDataOut);
            }

//------------------------------------------------------------------------------------
///     Fin du balayage des champs de la fiche

          } // Fin foreach($valeursFiche as $balise=>$valFiche)

///------------------------------------------------------------------------------------
///
///     => Supprimer les attributs 'VALUE' non renseigns - !x!...!x!
          $xmlDataOut = ereg_replace("!x![^!]*!x!", '', $xmlDataOut);

///     => Supprimer les balises conditionnelles non satisfaites :
///           !v!balise!v!texte!/v!           Affichage "texte" si <balise> non vide
///           !y!balise!y!texte!/y!           Affichage "texte" si <balise>=url
///           !w!balise!w!test!w!texte!/w!    Affichage "texte" si <balise>="test"
	        $regexp_suppr = "![yvw]!([^!]|![^/]|!/[^yvw]|!/[yvw][^!])*!/[yvw]!";
          $xmlDataOut = ereg_replace($regexp_suppr,'', $xmlDataOut);

if($debugAppli) $debugAppli->show($xmlDataOut,'renseignerBalisesDsModele - Fiche finale');
//if($debugAppli) { $debugAppli->close(); unset($debugAppli); }

//------------------------------------------------------------------------------------
        } // Fin function renseignerBalisesDsModele()
//------------------------------------------------------------------------------------

///
///====================================================================================
///    function FicheXML_processingInstructionHandler($parser, $target, $data) { global $debugAppli;
    function FicheXML_processingInstructionHandler($parser, $target, $data) { global $debugAppli;
///====================================================================================
/// Traitement d'un script
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $target   Langage du script
///    $data     Script  traiter
///
///====================================================================================
      global $baliseEnCours, $attributsBaliseEnCours, $xmlDataOut;
///------------------------------------------------------------------------------------
///
      if(strtolower($target)=='php') {
//***Securit***        eval($data);
      } // Fin if(strtolower($target)=='php')

    } // Fin function FicheXML_processingInstructionHandler($parser, $target, $data)


///
///====================================================================================
///    function FicheXML_defaultHandler($parser, $data) { global $debugAppli;
    function FicheXML_defaultHandler($parser, $data) { global $debugAppli;
///====================================================================================
/// Traitement d'une balise sans handler
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $data     Texte  traiter
///
///====================================================================================
      global $baliseEnCours, $attributsBaliseEnCours, $xmlDataOut;
///------------------------------------------------------------------------------------
///

    } // Fin function FicheXML_defaultHandler($parser, $data)


//
//====================================================================================
// Fin du fichier DocXml_FicheXML.php
?>