<?php
//====================================================================================
///                                                       Fichier : nouvelleFiche.php
//global $debugAppli;
//include "Tools/classeDebug.php";
//if(!$debugAppli) $debugAppli = new DEBUG;
//
///===================================================================================
///
///   Ajout/Modification d'une fiche
///
///   Traitement du formulaire de cration/modification d'une fiche
///
///====================================================================================
/// Paramtres
///    $TypeDocXML                   Type de fiche
///                                     Si vide : sera renseign par $xml_TypeFicheXML
///    $Handler                      Handler pour le traitement XML
///    $xml_ProcessXML_Requete       = 'ModifFiche' ou 'NouvelleFiche'
///    $xml_ProcessXML_Retour        Adresse de retour aprs importation
///                                    (avec paramtres... sauf nouvel "id_objetSpip")
///    $NomBalises[]                 Noms des balises
///    $ValBalises[]                 Valeurs des balises
///                                  NB: Si elles contiennent des balises HTML, celles-ci sont
///                                      reues sous la forme "<balise>"
///
///    $xml_TypeFicheXML             Identifie les modles d'importation dans Spip  utiliser.
///                                  Cf. ${'import_'.ucFirst($xml_TypeFicheXML)} dans "paramsAppli.php"
///                                  = Entit : 'Document', 'Etablissement' ou 'Projet' ou ...
///
///    $xml_ObjetSpip                Identifie l'objet Spip (principal si plusieurs) qui sera import
///                                     dans Spip, puis index.
///                                  Cf. indexer_$xml_ObjetSpip (${id_$xml_ObjetSpip})
///                                  = 'article', 'rubrique', 'breve', 'forum', ...
///                                  NB: L'objet Spip devra avoir le mot-cl
///                                      "TypeFicheXML"=$xml_ObjetSpip
///
///    $xml_ParamsObjetSpip          Pour renseigner les id ncessaires dans le modle d'importation
///                                  = id_objetSpip=aaa&id_xxx=bbb&id_yyy=ccc&...
///
///    Si $xml_ObjetSpip='article' :
///      $xml_ParamsObjetSpip        = 'id_objetSpip=vvv&id_rubrique=xxx&id_secteur=yyy'
///                                       o vvv = id de l'objet  modifier ($xml_ProcessXML_Requete='ModifFiche')
///                                                ou 0 ($xml_ProcessXML_Requete='NouvelleFiche')
///                                          xxx = id de la rubrique devant contenir la nouvelle fiche 'article'
///                                       et yyy = id du secteur associ
///    Si $xml_ObjetSpip='rubrique' :
///      $xml_ParamsObjetSpip        = 'id_objetSpip=vvv&id_parent=xxx&id_secteur=yyy'
///                                       o vvv = id de l'objet  modifier ($xml_ProcessXML_Requete='ModifFiche')
///                                                ou 0 ($xml_ProcessXML_Requete='NouvelleFiche')
///                                          xxx = id de la rubrique devant contenir la nouvelle fiche 'rubrique'
///                                       et yyy = id du secteur associ
///
///====================================================================================
/// Traitements
///    Les champs de formulaire reus
///          $NomBalises[] / $ValBalises[]
///       sont rangs dans $balises[nom_paramtre]=valeur_paramtre
///    Epurs des champs pour lesquels $ValBalises[]='noBaliseFermante' (ces champs
///       servent  gnrer le XML de la fiche), ils sont rangs dans
///       $attributs[nom_paramtre]=valeur_paramtre
///
///    Les paramtres reus sont aussi cods en XML dans $attributs['FicheXML']
///       sous la forme :
///
///       <DocumentXML TypeDocXML="$TypeDocXML" Handler="$Handler">
///          .....
///          <nom_paramtre>valeur_paramtre</nom_paramtre>
///          .....
///       </DocumentXML>
///
///    Dans un modle d'article ou de rubrique " importer" dans Spip,
///       on renseigne les balises adhoc avec les paramtres reus.
///       Pour ce faire, le contenu  renseigner y est identifi par '!balise!':
///       on y remplace '!balise!' par $balises['balise'].
///
///====================================================================================
  global $Erreur_getUpLoadedFile;

  header('Expires: 0');

//------------------------------------------------------------------------------------
// Charger le module "mes_fonctions.php"
// Il inclut paramsAppli + inc_version + inc_connect
    include 'mes_fonctions.php';

  	if(is_file('ecrire/inc_connect.php3')) {
  	  include 'ecrire/inc_filtres.php3';
  	  include 'ecrire/inc_meta.php3';
  	  include 'ecrire/inc_import.php3';
  	  include 'ecrire/inc_index.php3';
  	}	else {
  	  include 'ecrire/inc_filtres.php';
  	  include 'ecrire/inc_meta.php';
  	  include 'ecrire/inc_import.php';
  	  include 'ecrire/inc_index.php';
  	}

    if(file_exists('Tools/getUploadedFile.php')) include 'Tools/getUploadedFile.php';

if($debugAppli) $debugAppli->traceParametres('nouvelleFiche.php');

//------------------------------------------------------------------------------------
///------------------------------------------------------------------------------------
///
if(!is_array($NomBalises) || !count($NomBalises)) {
  $errNouvelleFiche = 1;
?>
  <script>alert("Bug !!!  Pas de paramtres NomBalises !!!\n\nVeuillez contacter le webmaster...");</script>
<?
} else {
//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
/// Mmoriser toutes les balises reues dans
///        $balises[$balise]=$val => pour crer la fiche XML
///
    $checkVals  = array();
    $filesToGet = array();

    for($i=0; $i<count($NomBalises); $i++) {
      $balise = $NomBalises[$i];                        // Nom de la balise
      $val    = $ValBalises[$i];                        // Valeur de la balise
      $balisesFicheXML[$balise] = stripSlashes($val);   // ...pour gnrer la fiche XML

//------------------------------------------------------------------------------------
/// Identifier les ventuels fichiers  charger sur le serveur
      if($val!='noBaliseFermante' && eregi('^upload_[0-9]*_$', $balise))
        $filesToGet[] = $balise;                                // Balise d'un fichier  charger

//------------------------------------------------------------------------------------
/// Sauver les multiples valeurs d'une balise de type CHECKBOX ou RADIO
      $nomChkRadio = $balise.'CheckRadio';
      if(!strpos(",$nomChkRadio",'/')                           // Ce n'est pas une balise fermante
         && is_array($$nomChkRadio) && count($$nomChkRadio)) {  // et elle est non vide

        foreach($$nomChkRadio as $check) {
          $j = strpos($check, ' ');                     // $check="balise valeur"
          $balise = substr($check, 0, $j);              // Balise
          $val    = substr($check, $j+1);               // Valeur
          $checkVals[$balise] .= ";$val";
        } // Fin foreach($$nomChkRadio as $check)

      } // Fin if(!strpos(",$nomChkRadio",'/')...

//------------------------------------------------------------------------------------
/// Sauver les multiples valeurs d'une balise de type SELECT MULTIPLE (SelectM)
      $nomSelect = $balise.'Select';
      if(!strpos(",$nomSelect",'/')                         // Ce n'est pas une balise fermante
         && !$selectVals[$balise]                           // Non dj traite
         && is_array($$nomSelect) && count($$nomSelect)) {  // Non vide

        foreach($$nomSelect as $option) {
          $j = strpos($option, ' ');                     // $option="balise valeur"
          $balise = substr($option, 0, $j);              // Balise
          $val    = substr($option, $j+1);               // Valeur
          $selectVals[$balise] .= ";$val";
        } // Fin foreach($$nomSelect as $check)

      } // Fin if(!strpos(",$nomSelect",'/')...

//------------------------------------------------------------------------------------

    } // Fin for($i=0; $i<count($NomBalises); $i++)

//------------------------------------------------------------------------------------
/// Traiter les inputs de type CHECKBOX ou RADIO
///
    if(count($checkVals)) {

      foreach($checkVals as $balise=>$val) {
        $val = substr($val,1);                          // Supprimer le 1er point-virgule
        $balisesFicheXML[$balise] = stripSlashes($val); // Pour la fiche XML
// Balises renseignes => Pas de balise de fin spcifique
        unset($balisesFicheXML["/$balise"]);
      } // Fin foreach($checkVals as $balise=>$val)

    } // Fin if(count($checkVals))

//------------------------------------------------------------------------------------
/// Traiter les inputs de type SELECT MULTIPLE
///
    if(count($selectVals)) {

      foreach($selectVals as $balise=>$val) {
        $val = substr($val,1);                          // Supprimer le 1er point-virgule
        $balisesFicheXML[$balise] = stripSlashes($val); // Pour la fiche XML
// Balises renseignes => Pas de balise de fin spcifique
        unset($balisesFicheXML["/$balise"]);
      } // Fin foreach($selectVals as $balise=>$val)

    } // Fin if(count($selectVals))

//------------------------------------------------------------------------------------
/// Rcuprer les fichiers  charger sur le serveur

    if(count($filesToGet)) {
      if(!$dirRessources=$PathToRessources) $dirRessources = 'Ressources';

      foreach($filesToGet as $baliseFic) {

/// Charger le fichier sur le serveur
/// => Appel  getUploadedFile($baliseFic, 'Ressources', $balisesFicheXML[$baliseFic])

        $nomFicSurServeur = getUploadedFile($baliseFic, $dirRessources, $balisesFicheXML[$baliseFic]);

/// Renseigner les balises  gnrer dans la fiche XML...
        if(is_file($nomFicSurServeur)) {
          $suffixe = ereg_replace('^.*(_[0-9]+_)$', '\1', $baliseFic);
          $tailleFichier = (int) ceil(fileSize($nomFicSurServeur)/1024);
          $balisesFicheXML["CheminFic$suffixe"] = $nomFicSurServeur;
          $balisesFicheXML["NomUser$suffixe"]   = baseName($nomFicSurServeur);
          $balisesFicheXML["TailleFic$suffixe"] = $tailleFichier;
          unset($balisesFicheXML[$baliseFic]);

        } // Fin if(is_file($nomFicSurServeur)) {

///    En cas d'erreur, la fiche sera qd mme cre... mais sans le fichier !
        if($Erreur_getUpLoadedFile) {
?>
            <script>alert("<?=$Erreur_getUpLoadedFile?>");</script>
<?
        }

      } // Fin foreach($filesToGet as $baliseFic)

    } // Fin if(count($filesToGet))

//------------------------------------------------------------------------------------
///------------------------------------------------------------------------------------
/// Rcuprer les attributs du modle dans $attributsModele[balise]
///
/// Si un balise contient du code HTML dans sa valeur par dfaut
///    (cf. $attributsModele[balise]['Defaut']), celui-ci sera reu
///    sous la forme "<baliseHTML>")
/// => Appel  processXml('', "Modele$TypeDocXML")

    if(!$TypeDocXML) $TypeDocXML = $xml_TypeFicheXML;
if($debugAppli) $debugAppli->show('',"------- Appel processXml('', \"Modele$TypeDocXML\")");

    $xml_Fiche_Formulaire = 'Modele';                     // Pas d'output...
    $attributsModele = array();

    processXml('', "Modele$TypeDocXML");                      // Retour dans $attributsModele

if($debugAppli) $debugAppli->show('','------- Retour ds nouvelleFiche.php');
//if($debugAppli) $debugAppli->show($attributsModele,'attributsModele');

    $attributs = array();
    foreach(array_keys($attributsModele) as $balise) {

// NB: Ci-dessous : sparateur ';' entre balises.
//     Pour une mme balise, sparateur ',' entre filtres.

/// Se souvenir des ventuels filtres "FromInput"
      if($filtre=$attributsModele[$balise]['FiltreFromInput']) {
        $attributs['FiltreFromInput'] .= ";$filtre";
        $attributs['FiltreFromInput']  = ereg_replace('^;','',$attributs['FiltreFromInput']);
        $attributs['baliseFiltreFromInput'] .= ";$balise";
        $attributs['baliseFiltreFromInput']  = ereg_replace('^;','',$attributs['baliseFiltreFromInput']);
      }

/// Se souvenir des ventuels filtres "avant import"
      if($filtre=$attributsModele[$balise]['FiltreAvantImport']) {
        $attributs['FiltreAvantImport'] .= ";$filtre";
        $attributs['FiltreAvantImport']  = ereg_replace('^;','',$attributs['FiltreAvantImport']);
        $attributs['baliseFiltreAvantImport'] .= ";$balise";
        $attributs['baliseFiltreAvantImport']  = ereg_replace('^;','',$attributs['baliseFiltreAvantImport']);
      }

/// Se souvenir des ventuels filtres "aprs import"
      if($filtre=$attributsModele[$balise]['FiltreApresImport']) {
        $attributs['FiltreApresImport'] .= ";$filtre";
        $attributs['FiltreApresImport']  = ereg_replace('^;','',$attributs['FiltreApresImport']);
        $attributs['baliseFiltreApresImport'] .= ";$balise";
        $attributs['baliseFiltreApresImport']  = ereg_replace('^;','',$attributs['baliseFiltreApresImport']);
      }

    } // Fin foreach(array_keys($attributsModele) as $balise)

//------------------------------------------------------------------------------------
/// Complter les balises  utiliser dans la fiche (cf. $balisesFicheXML)
/// NB: Ces balises ne seront pas affiches car inconnues des modles...)

    unset($balisesFicheXML['Date']);  // Forcer une date Spip (utilis avec une date franaise !!!)
    $balisesFicheXML['editDate']  = date('Y-m-d H:i:s'); // 2002-01-15 13:57:23
    $balisesFicheXML['userName']  = $userName;
    $balisesFicheXML['userEmail'] = $userEmail;

//------------------------------------------------------------------------------------
/// Renseigner les attributs  utiliser dans l'importation Spip

    foreach($balisesFicheXML as $balise=>$attribut)
      if($attribut!='noBaliseFermante')
        $attributs[$balise] = $attribut;

//------------------------------------------------------------------------------------
/// Renseigner les id des mots-cls

    $sql = "SELECT id_mot,id_groupe,titre,type FROM spip_mots ";
    $res = spip_query($sql);
    while( list($id_mot,$id_groupe,$mot,$type_mot)=mysql_fetch_row($res) ) {
      $attributs["id_mot_$mot"]     = $id_mot;
      $attributs["id_groupe_$mot"]  = $id_groupe;
      $attributs["nom_groupe_$mot"] = $type_mot;
    }
    mysql_free_result($res);


//------------------------------------------------------------------------------------
///------------------------------------------------------------------------------------
/// Traiter les crations de nouvelles entres (balises "New...")
//------------------------------------------------------------------------------------
/// => Rechercher les balise de nom "NewXxxx"

    foreach(array_keys($attributs) as $newBalise) {                            // $newBalise='NewXxxx'

      if(($balise=ereg_replace('^New(.*)$', '\1', $newBalise))!=$newBalise) {  // $balise='Xxxx'
if($debugAppli) $debugAppli->show($newBalise,'Dtection "NewBalise"');

        if($attributs[$newBalise]                               // ... non vide
           && isset($attributs[$balise])                        // L'attribut 'xxxxxx' existe
           && empty($attributs[$balise]) )                      // ... et est vide
        {
if($debugAppli) $debugAppli->show('',"--- Traitement --- NEW --- balise=$balise ---");
          if($attributsModele[$balise]['TypeInput']=='Select+'
               || $attributsModele[$balise]['TypeInput']=='SelectM+') // ATTENTION ... switch ci-dessous

//------------------------------------------------------------------------------------
// La cration d'une nouvelle entre est OK...

            switch($attributsModele[$balise]['TypeMaj']) {      // ATTENTION ... suite if ci-dessus

/// => Si les options viennent d'une table 'Spip' :
///     => Rcuprer le gabarit d'importation adhoc
              case 'Import' :

//------------------------------------------------------------------------------------
///     => Rechercher les paramtres d'importation
                $tableWhere = $attributsModele[$balise]['TableWhereImport'];
                $chpWhere   = $attributsModele[$balise]['ChpWhereImport'];
                $table = $attributsModele[$balise]['TableImport'];
                $chps  = $attributsModele[$balise]['ChpImport'];   // tbl.chp1,tbl.chp2
                $vars  = $attributsModele[$balise]['VarImport'];   // chp1,chp3
                $from  = "FROM $table";
                if($tableWhere) $from .= " , $tableWhere";
                $where = '';
                if($chpWhere) $where  = "WHERE $chpWhere ";

                $sql = "SELECT $chps ".
                       "$from ".
                       "$where ";
if($debugAppli) $debugAppli->show($sql,"$newBalise - Import - sql");
                $res = spip_query($sql);
                $row = mysql_fetch_row($res);
                mysql_free_result($res);
if($debugAppli) $debugAppli->show($row,"$newBalise - Import - row");

          			$vars = explode(',',$vars);                        // $vars = array('chp1','chp3')
          			$i = 0;
          			foreach($vars as $nomVar) {
          			  $attributs["$nomVar"] = $row[$i];                // $attributs['chpk'] = $row[$i];
          			  $i++;                                            // Ex: $attributs['id_rubrique']...
if($debugAppli) $debugAppli->show($attributs["$nomVar"],"attributs['$nomVar']");
          			}

//------------------------------------------------------------------------------------
///     => Importer les objets adhoc dans Spip
///
                importObjectIntoSpip($balise, $attributs);

///     => Rcuprer l'id de l'objet "principal" cr dans la base
                eval( '$id = $attributs["first_id_'.$attributs['first_objetSpip'].'"];' );

///     => Rcuprer les paramtres du champ "normal"
                $table      = $attributsModele[$balise]['Table'];
                $chpId      = $attributsModele[$balise]['ChpId'];        // Cl primaire dans la table (dans "value")
                $chpsValue  = $attributsModele[$balise]['ChpValOption']; // chp1,chp2 (autres chps dans "value")

                $chps = $chpId;
                if($chpsValue) $chps .= ",$chpsValue";                   // => tbl.chpId,tbl1.chp1,tbl2.chp2

                $chps0  = ereg_replace('[0-9a-zA-Z_]*\.','',$chps);      // chpId,chp1,chp2
                $chps1  = split(' *, *', "$chps0");                      // array(chpId,chp1,chp2)
                $chps2  = '$'.join(',$', $chps1);                        // => $chpId,$chp1,$chp2

                $sql = "SELECT $chps ".
                       "FROM  $table ".
                       "WHERE $chpId=$id ";
                $res  = spip_query($sql);
                $row = mysql_fetch_row($res);
                mysql_free_result($res);

          			eval( "list($chps2) = \$row;" );                         // list($chpId,$chp1,$chp2) = $row;
            	  eval( "\$chps3 = \"$chps2\";" );                         // eval( $chps3 = "$chpId,$chp1,$chp2"; );

if($debugAppli) $debugAppli->show($sql,"$newBalise - Import - sql");
if($debugAppli) $debugAppli->show($id,"$newBalise - Import - id");

///     => Renseigner la "vraie" balise avec la nouvelle entre
                $balisesFicheXML[$balise] = $chps3;
                $attributs[$balise] = $chps3;

                break;

//------------------------------------------------------------------------------------
/// => Si les options viennent d'une table 'Appli' :
///     => Ajouter l'enregistrement adhoc dans la table
              case 'Table' :

                $txt = $attributs[$newBalise];                           // Nouveau libell
                $sql = "INSERT INTO ".$attributsModele[$balise]['Table']." ".
                       "(".$attributsModele[$balise]['ChpTxt'].") ".
                       "VALUES (\"$txt\") ";
                spip_query($sql);
                $id = mysql_insert_id();                                 // Rcuprer le champ identifiant

if($debugAppli) $debugAppli->show($sql,"$newBalise - Table - sql");
if($debugAppli) $debugAppli->show($id,"$newBalise - Table - id");

///     => Renseigner la "vraie" balise avec la nouvelle entre
                $balisesFicheXML[$balise] = "$id,$txt";
                $attributs[$balise] = "$id,$txt";

                break;

            } // Fin if($attributsModele[$balise]['TypeInput']=='Select+' || ... ) switch ...

if($debugAppli) $debugAppli->show($attributs[$balise],"attributs[$balise]");

//------------------------------------------------------------------------------------
        } // Fin if($attributs[$newBalise]) ... else ...

/// => Supprimer la balise "Newxxxxx"
        unset($balisesFicheXML[$newBalise]);
        unset($attributs[$newBalise]);

      } // Fin if(($balise=ereg_replace....

    } // Fin foreach(array_keys($balises) as $newBalise)
//------------------------------------------------------------------------------------
/// Fin traitement des nouvelles entres (balises "New...")
///------------------------------------------------------------------------------------


//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
/// Excuter les ventuels filtres "from input"
    if($fct=$attributs['FiltreFromInput']) {

if($debugAppli) $debugAppli->show($fct,"attributs['FiltreFromInput']");
      $filtres    = explode(';', $fct);                                     // Filtres...
      $baliseFcts = explode(';', $attributs['baliseFiltreFromInput']);      // ...et balises associes

      for($j=0; $j<count($filtres); $j++) {
        $filtre = $filtres[$j];
        $balise = $baliseFcts[$j];
        $attribut = $balisesFicheXML[$balise];

        $fcts = explode(',', $filtre);                                      // Filtre
        foreach($fcts as $fct)                                              // Excuter chaque filtre
          eval("\$attribut=$fct"."(\$attribut);");                          //    sur la valeur de la balise
        $balisesFicheXML[$balise] = $attribut;                              // Nouvelle valeur
        $attributs[$balise]       = $attribut;
      }

    } // Fin if($fct=$attributs['FiltreFromInput'])

    unset($attributs['FiltreFromInput']);
    unset($attributs['baliseFiltreFromInput']);

//------------------------------------------------------------------------------------
///------------------------------------------------------------------------------------
/// Convertir les paramtres reus en XML (<attribut>valeur</attribut>)
/// (les balises sont les lments du tableau $balisesFicheXML)

    $ficheXML = '';

    foreach($balisesFicheXML as $balise => $val) {

      if($val=='noBaliseFermante') {
        $ficheXML .= "\n<$balise>";
      } else {
/// ATTENTION : Dans la base, les balises HTML sont codes balise
        $ficheXML .= "\n<$balise>".HTMLtoCode($val)."</$balise>";
      }
    } // Fin foreach($balisesFicheXML as $balise => $val)
if($debugAppli) $debugAppli->show($ficheXML,'...ficheXML');

//------------------------------------------------------------------------------------
/// Construire la fiche XML

    $ficheXML = "<DocumentXML TypeDocXML=\"$TypeDocXML\" Handler=\"$Handler\">".
                $ficheXML.
                "\n</DocumentXML>";

// Masquer les balises XML de la fiche pendant l'analyse du modele d'importation (en XML aussi!)
    $ficheXML = str_replace('<','&lt;', str_replace('&','&amp;', $ficheXML));

/// ATTENTION : La fiche sera introduite dans le corps d'une balise XML (cf. modele d'importation).
///             Les balises HTML ventuellement prsentes dans le corps des balises XML de la fiche
///             ont dj t codes "baliseHTML"...
    $attributs['FicheXML'] = $ficheXML;

//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
/// Rcuprer les id Spip ...
/// ... et les placer dans $attributs pour le renseignement du fichier d'importation
if($debugAppli) $debugAppli->show($xml_ParamsObjetSpip, 'Rcup ids ds xml_ParamsObjetSpip');

    $ids = explode('&', $xml_ParamsObjetSpip);
    foreach($ids as $id) if($id) {
      list($nom, $val) = explode('=', $id);
      $attributs[$nom] = urlDecode($val);                             // Ex: $attributs['id_parent'] = $val;
if($debugAppli) $debugAppli->show($attributs[$nom], "xml_ParamsObjetSpip - attributs[$nom]");
    } // Fin foreach($ids as $id)

    eval( "\$id_$xml_ObjetSpip = \$attributs['id_objetSpip'];");      // Ex: $id_rubrique = $attributs['id_objetSpip'];
    eval( "\$attributs['id_$xml_ObjetSpip'] = \$id_$xml_ObjetSpip;"); // Ex: $attributs['id_rubrique'] = $id_rubrique;

if($debugAppli) $debugAppli->show($attributs["id_$xml_ObjetSpip"], "id_objetSpip='id_$xml_ObjetSpip'");

//------------------------------------------------------------------------------------
/// Traiter l'importation d'un objet devant tre valid par un administrateur
    if(($id=$attributs['id_rubrique'] && !adminRubrique($id))
       || ($id=$attributs['id_secteur'] && !adminRubrique($id))) {

    } // Fin if(($id=$attributs['id_rubrique'] && !adminRubrique($id))...

//------------------------------------------------------------------------------------
/// Excuter les ventuels filtres "avant import"
    if($fct=$attributs['FiltreAvantImport']) {

if($debugAppli) $debugAppli->show($fct,"attributs['FiltreAvantImport']");
      $filtres    = explode(';', $fct);                                     // Filtres...
      $baliseFcts = explode(';', $attributs['baliseFiltreAvantImport']);    // ...et balises associes

      for($j=0; $j<count($filtres); $j++) {
        $filtre = $filtres[$j];
        $balise = $baliseFcts[$j];

        $fcts = explode(',', $filtre);                                      // Filtre
        foreach($fcts as $fct)
          eval("\$attributs[\$balise.'_FavI_']=$fct"."('$balise');");                                        // Excuter chaque filtre
      }
    }

    unset($attributs['FiltreAvantImport']);
    unset($attributs['baliseFiltreAvantImport']);

if($debugAppli) $debugAppli->show($attributs,'--- attributs ---');

//------------------------------------------------------------------------------------
///------------------------------------------------------------------------------------
/// Importation du nouvel objet
///------------------------------------------------------------------------------------
///     => Importer les objets adhoc dans Spip
///
        importObjectIntoSpip(ucFirst($xml_TypeFicheXML), $attributs);

///     => Rcuprer l'id de l'objet "principal" cr dans la base
////////        $id = $attributs["id_$xml_ObjetSpip"]; //////// Peut tre ambigu...
        $objetSpip = $attributs['first_objetSpip'];
        $id = $attributs["first_id_$objetSpip"];

        eval( "if(!\$id_$xml_ObjetSpip) \$id_$xml_ObjetSpip = $id;" );

if($debugAppli) $debugAppli->show($id, "attributs['first_id_$xml_ObjetSpip'] aprs majBaseSpip()");
//------------------------------------------------------------------------------------
/// Indexer l'article/rubrique cr/mis  jour

    if(!$errNouvelleFiche && function_exists("indexer_$xml_ObjetSpip"))
      eval( "indexer_$xml_ObjetSpip"."(\$id);" );

//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------

} // Fin if(!is_array($NomBalises) || !count($NomBalises))... else...

//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
// Fin traitements => retour  la page ayant appel le formulaire trait
//------------------------------------------------------------------------------------
/// Recharger la page appelante avec ventuellement le nouvel objet Spip

    $retour = '';
    if($xml_ProcessXML_Retour) {              // Url de retour
      $retour  = "$xml_ProcessXML_Retour".
                 "?$xml_Params_Retour".
///////                 "&id_$xml_ObjetSpip=$id".
                 "&recalcul=oui".
                 "";
      $retour = str_replace('?&','?',$retour);
    } // Fin if($xml_ProcessXML_Retour)

if($debugAppli) $debugAppli->show($retour,'Retour appelant');
if($debugAppli) { $debugAppli->close(); }
//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
?>
<HTML>
  <BODY>
<?
    if($errNouvelleFiche ) {
?>
      <SCRIPT>
<?
        if(!$debugAppli) {                // PHP
?>       top.history.go(-2);              // JavaScript
<?      }                                 // PHP
?>
      </SCRIPT>
<?
    } // Fin if($errNouvelleFiche )

//------------------------------------------------------------------------------------
?>
    <SCRIPT>
// Attendre pour pouvoir rcuprer les traces debug
      msg = "Trace nouvelleFiche.php dispo...\n\nRetour"; // JavaScript
<?
      if($retour) {                                   // PHP
?>      retour = "<?=$retour;?>";                     // JavaScript : Url de retour fournie par l'appelant
        msg += "="+retour;
<?    } else {                                        // PHP
?>
        if(opener) {                                  // JavaScript : La page courante est un popup
          p = new Array();
          p[0] = "recalcul=oui";
          retour = addToSelf(opener.window,p)
          msg += " via opener="+retour;
        } else {
          retour = "";                                // Pour afficher la page prcdente
          msg += " via history(-2)";
        } // Fin if(opener)... else...

<?    } // Fin if($retour)... else...                 // PHP

// Permettre le debug de "nouvelleFiche.php" avant l'appel  la page appelante
      if($debugAppli) {                               // PHP
?>      if(confirm(msg)) {                            // JavaScript : Debug => attendre la suite...
<?    } else {                                        // PHP
?>      if(true) {                                    // JavaScript : Pas de debug => pas d'attente !
<?    } // Fin if($debugAppli)... else...                  // PHP
?>
// Recalculer le contenu de la page appelante
          if(retour) {                                // JavaScript : On a une url de retour
            window.document.location.href=retour;
          } else {                                    // Pas d'url o aller !?!
            window.history.go(-2);                    // Page prcdente (sans recalcul !)
          } // Fin if(retour)

        } // Fin if(confirm(msg)) ou if(true)

    </SCRIPT>

  </BODY>
</HTML>
